diff --git a/common/ppc/pixel.c b/common/ppc/pixel.c
index bd52f5e..fc8b417 100644
--- a/common/ppc/pixel.c
+++ b/common/ppc/pixel.c
@@ -1675,10 +1675,10 @@ static int x264_pixel_var_8x8_altivec( uint8_t *pix, int i_stride )
     static const vec_u8_t perm_tab[] = {
         CV(0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,  /* pix=mod16, i_stride=mod16 */
            0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17),
-        CV(0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,  /* pix=mod16, i_stride=mod8  */
+        CV(0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,  /* pix=mod8, i_stride=mod16  */
            0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F),
     };
-    vec_u8_t perm = perm_tab[ ((i_stride & 8) >> 3) ];
+    vec_u8_t perm = perm_tab[ ((uintptr_t)pix & 8) >> 3 ];
 
     int y;
     for( y = 0; y < 8; y+=2 )
